<?php // Script par www.jsand.net !

/* LICENCE GNU/GPL - licence.txt
 * Vous devez avoir lu et accept les conditions imposes par la licence GNU/GPL (licence.txt ci-joint)
 * pour utiliser ce script.
*/


/*
	Placez ce fichier au beau milieu de vos dossiers photos.

	URL A DIFFUSER :
	************************
	- http://votresite.com/mesphotos/?nom_du_dossier : afficher les photos d'un dossier en visionneuse

	- http://votresite.com/mesphotos/?pointeur_menu : afficher le menu des visionneuses
		- http://votresite.com/mesphotos/?pointeur_menu&type=prive : 'type=' indique le mode du menu, 'prive' pour uniquement les prives, 'public' pr les autres et 'all' pour toutes.
		Si 'type=' n'est pas indiqu, la valeur par dfaut prise en compte sera celle indique dans les options.

	- http://votresite.com/mesphotos/?nom_du_dossier&csa : mode censur de la visionneuse
	- HP065819_pointeur.jpg : photo  censurer
	- pointeur_nomdudossier/ : dossier publique sans mot de passe
	*********

	* Les sous-visionneuses (sous-dossiers) seront affichs en menu au dessus de la visionneuse
	* Vous pouvez indiquer des sous-visionneuses spciales et universelles (ex: videos/, music/) qui contiendront autre chose que des photos
	* Vous pouvez indiquer un nom de dossier universel qui ne sera jamais list ni visionn (ex: perso/)
	* Pensez ventuellement  ajouter un fichier index.html vide dans vos dossiers photos

	Voir les OPTIONS pour dfinir les pointeurs.
*/


/*********************/
/****** OPTIONS ******/
/*********************/

$visionneuse = 'http://votresite.com/mesphotos/'; // Adresse absolue de la visionneuse (ex: http://votresite.com/mesphotos/) avec un slash final

$pointeur_menu = 'menu'; // Pointeur de la page menu (ex: ?menu)
$pointeur_filtreur = 'csa'; // Pointeur  ajouter pour activer le filtre (ex: ?vacances&csa)
$pointeur_filtre = '_censured'; // Pointeur des photos  filtrer (ex: toto_censured.jpg)
$pointeur_public = 'public_'; // Pointeur par lequel commenceront les albums publiques (ex: le dossier "public_vacances/")

$type_menu = 'all'; // Le menu affichera par dfaut les visionneuses prives ('prive'), publiques ('public'), ou toutes mlanges ('all')
$dossier_perso = 'perso'; // Nom du dossier du serveur que la visionneuse ne pourra jamais lire

$mot_de_passe = 'luckyluke'; // Mot de passe des albums privs
$max_essais = 3; // Nombre d'essais maximum du mot de passe avant d'tre banni
$page_banni = 'http://www.google.fr'; // Page vers laquelle renvoyer lorsque l'on est banni
$pht_page_defaut = 10; // Nombre de photos sur une page par dfaut
$lien_menu = 1; // Afficher un lien de retour vers le menu sur les visionneuses (0 pour non, 1 pour oui)

// Les sous-dossiers qui contiennent autre chose que des photos (universels pour toutes les visionneuses)
//	'nom_du_dossier => 'Titre du dossier'
$dossiers_speciaux = Array(
	'videos' => 'LES VIDEOS',
	'music' => 'LES MUSIQUES'
);




/********************/
/****** SCRIPT ******/
/********************/

session_start();

// Rcupration du nom de l'album  afficher & infos
foreach($_GET as $key => $value) {
	if($key != 'p' && $key != 'n' && $key != $pointeur_filtreur && $key != 'listing' && $key != 'login' && $key != 'deconnect' && empty($value))
		$album = $key;
}

$p = (isset($_GET['p']) && is_numeric($_GET['p']) && $_GET['p'] > 0) ? $_GET['p'] : 1;
$n = (isset($_GET['n']) && is_numeric($_GET['n']) && $_GET['n'] > 0) ? $_GET['n'] : $pht_page_defaut;
$filtre = (isset($_GET[$pointeur_filtreur])) ? true : false;
$listing = (isset($_GET['listing'])) ? true : false;
$menu = ($album == $pointeur_menu) ? true : false;
$options_url = ($n != 10) ? '&amp;n='.$n : null;
$options_url .= ($filtre) ? '&amp;'.$pointeur_filtreur : null;
$options_url .= ($listing) ? '&amp;listing' : null;

// On redfini le type de $menu si prcis
if(isset($_GET['type'])) {
	if($_GET['type'] == 'public' || $_GET['type'] == 'prive' || $_GET['type'] == 'all')
		$type_menu = $_GET['type'];
}

if(eregi($pointeur_public, $album))
	define('PUBLIQUE', true);
else
	define('PUBLIQUE', false);


// On vrifie si le dossier existe ou n'est pas spcial
if((!file_exists($album) || $album == $dossier_perso || $album == 'sessions') && !$menu)
	exit('<em>Destination inconnue</em>');


// Si l'album n'est pas publique, on vrifie le mot de passe et si on est banni
if(!PUBLIQUE) {
	// Si on est banni, on ne vrifie mme pas la connexion
	if($_SESSION['login'] === false && $_SESSION['essais'] === false)
		header('Location: '.$page_banni);

	// Si on tente de se connecter (connexion permanente entre les albums)
	if(isset($_POST['login_on'])) {
		if($_SESSION['essais'] >= ($max_essais-1)) {
			$_SESSION['login'] = false;
			$_SESSION['essais'] = false;
			header('Location: '.$page_banni); // Banni
		} else {
			if($_POST['pass'] == $mot_de_passe) {
				$_SESSION['login'] = true;
				$_SESSION['essais'] = null;

				$plus = ($_POST['p'] != 1) ? '&p='.$_POST['p'] : null;
				$plus .= ($_POST['n'] != 10) ? '&n='.$_POST['n'] : null;
				$plus .= ($_POST['filtre'] != 0) ? '&'.$pointeur_filtreur : null;
				$plus .= ($_POST['listing'] != 0) ? '&listing' : null;

				header('Location: ?'.str_replace('&deconnect', null, str_replace('?deconnect', null, stripslashes(urldecode($album)))).$plus);
			} else {
				$_SESSION['login'] = false;
				$_SESSION['essais'] = (isset($_SESSION['essais'])) ? $_SESSION['essais']+1 : 1;
			}
		}
	}

	// Si on demande  se dconnecter
	if(isset($_GET['deconnect'])) {
		$_SESSION = array();
		session_destroy();
	}

	// Si on est pas connect, on renvoi vers la page de login
	if($_SESSION['login'] !== true && !isset($_GET['login']) && !$menu) {
		$plus = ($p != 1) ? '&p='.$p : null;
		$plus .= ($n != 10) ? '&n='.$n : null;
		$plus .= ($filtre) ? '&'.$pointeur_filtreur : null;
		$plus .= ($listing) ? '&listing' : null;
		header('Location: ?'.$album.$plus.'&login');
	}
}

// Si on est connect ou que l'album est publique
if(!isset($_GET['login'])) {

	// Rcupration et stockage des noms de photos du dossier concern
	if(!$menu && !$listing) {
		if($ouverture = opendir($album)) {
			$i=0;
			$corps = null;
			$corps_ssmenu = null;
			$photos = Array();
			$dossiers_photos = Array();

			while(false !== ($photo = readdir($ouverture))) {
				if($photo != '.' && $photo != '..' && $photo != 'index.html' && !($filtre && eregi($pointeur_filtre, $photo))) {
					if(is_dir($album.'/'.$photo))
						$dossiers_photos[] = $photo;
					else
						$photos[] = $photo;
				}
			}

			sort($photos);

			// Affichage de la visionneuse
			foreach($photos AS $photo) {
				if($i < $p * $n && $i >= ($p-1) * $n)
					$corps .= '<p><img src="'.$album.'/'.$photo.'" alt="* '.$photo.' - Appuyez sur F5 si je ne m\'affiche pas *" /></p>'."\n";
				$i++;
			}

			// Affichage des ventuelles sous-visionneuses en menu
			if(($p == 1 || $p == ceil($i/$n)) && !empty($dossiers_photos)) {
				$corps_ssmenu .= ($p == 1) ? '<div class="navigue gauche">'."\n" : '<div class="navigue gauche" id="navigue_bas">'."\n";
				$corps_ssmenu .= '<ul>'."\n";
				foreach($dossiers_photos AS $dossier_photos) {
					if(array_key_exists($dossier_photos, $dossiers_speciaux))
						$corps_ssmenu .= '<li><a href="?'.$album.'/'.$dossier_photos.'&listing">'.$dossiers_speciaux[$dossier_photos].'</a></li>'."\n";
					else
						$corps_ssmenu .= '<li><a href="?'.$album.'/'.$dossier_photos.$options_url.'"><em>'.ucfirst($dossier_photos).'</em></a></li>'."\n";
				}
				$corps_ssmenu .= '</ul>'."\n";
				$corps_ssmenu .= '</div>'."\n";

				if($p == 1)
					$corps = $corps_ssmenu.$corps;
				else
					$corps .= $corps_ssmenu;
			}

			closedir($ouverture);
		}

	// Si on demande le menu
	} elseif($menu) {
		$ouverture = opendir('.');

		$dossiers = Array();
		while(false !== ($dossier = readdir($ouverture))) {
			if($dossier != '.' && $dossier != '..' && $dossier != $dossier_perso && $dossier != 'sessions' && is_dir($dossier) && (($type_menu == 'prive' && !eregi($pointeur_public, $dossier)) || ($type_menu == 'public' && eregi($pointeur_public, $dossier)) || $type_menu == 'all'))
					$dossiers[] = (eregi($pointeur_public, $dossier)) ? str_replace($pointeur_public, null, $dossier).'__public_' : $dossier;
		}

		sort($dossiers);

		$corps = '<table id="menu"><tr><td>'."\n";
		$corps .= '<ul>'."\n";
		foreach($dossiers AS $dossier)
			$corps .= '<li><a href="?'.((eregi('__public_', $dossier)) ? $pointeur_public.str_replace('__public_', null, $dossier) : $dossier).'" title="Cliquez pour visionner">'.ucfirst(str_replace('__public_', null, $dossier)).'</a>'.(($type_menu == 'all') ? ((!eregi('__public_', $dossier)) ? '&nbsp; <span class="password">(Prive)</span>' : '&nbsp; <span class="public">(Publique)</span>') : null).'</li>'."\n";
		$corps .= '</ul></td>'."\n";

		$corps .= '<td id="ulright"><ul>'."\n";
		foreach($dossiers AS $dossier)
			$corps .= '<li><em>'.$visionneuse.'?'.((eregi('__public_', $dossier)) ? $pointeur_public.str_replace('__public_', null, $dossier) : $dossier).'</em></li>'."\n";
		$corps .= '</ul></td></tr>'."\n";
		$corps .= '</table>'."\n";

		$i = count($dossiers);
		closedir($ouverture);

	// Si on fait lister
	} elseif($listing) {
		$ouverture = opendir($album);

		$fichiers = Array();
		while(false !== ($fichier = readdir($ouverture))) {
			if($fichier != '.' && $fichier != '..' && $fichier != 'index.html' && $fichier != $dossier_perso && $fichier != 'sessions' && !eregi($pointeur_public, $fichier) && !is_dir($album.'/'.$fichier))
				$fichiers[] = $fichier;
		}

		sort($fichiers);

		$corps = '<table id="menu"><tr><td>'."\n";
		$corps .= '<ul>'."\n";
		foreach($fichiers AS $fichier)
			$corps .= '<li><a href="'.$album.'/'.$fichier.'" title="[Clic-droit > Enregistrer sous] pour tlcharger">'.$fichier.'</a></li>'."\n";
		$corps .= '</ul></td>'."\n";

		$corps .= '<td id="ulright"><ul>'."\n";
		foreach($fichiers AS $fichier)
			$corps .= '<li><em>'.$visionneuse.$album.'/'.$fichier.'</em></li>'."\n";
		$corps .= '</ul></td></tr>'."\n";
		$corps .= '</table>'."\n";

		$titre_listing = $dossiers_speciaux[substr(strstr($album, '/'), 1)];
		$visionneuse_mere = substr($album, 0, strrpos($album, '/'));
		$i = count($fichiers);
		closedir($ouverture);
	}

	// Gnration de la liste de page et des boutons Prcdent/suivant
	function navigue($nombre_de_photos) { // Fonction hrite de Signatux 1.0
		global $p, $n, $options_url, $album;

		$page_courante = $p;
		$nb_msg_par_page = $n;
		$out = '?'.$album.'&amp;p=';

		$nombre_de_pages = ceil($nombre_de_photos / $nb_msg_par_page);
		$page_suivante = $page_courante + 1;
		$page_precedente = $page_courante - 1;
		$pages = array();

		if($nombre_de_pages > 10) {
			if($page_courante > 6 && $page_courante < $nombre_de_pages - 4) {
				$pages[] = 1;
				$pages[] = '...';
				for($i=$page_courante-4; $i <= $page_courante + 4; $i++)
					$pages[] = $i;
				$pages[] = '...';
				$pages[] = $nombre_de_pages;
			}
			elseif($page_courante > 6) {
				$pages[] = 1;
				$pages[] = '...';
				for($i=$nombre_de_pages-8; $i <= $nombre_de_pages; $i++)
					$pages[] = $i;
			}
			elseif($page_courante < $nombre_de_pages - 4) {
				for($i=1; $i <= 10; $i++)
					$pages[] = $i;
				$pages[] = '...';
				$pages[] = $nombre_de_pages;
			}
		}
		else {
			for($i=1; $i <= $nombre_de_pages; $i++)
				$pages[] = $i;
		}

		$navigation = null;
		foreach($pages AS $page) {
			if($page != '...') {
				if($page == $page_courante)
					$navigation .= '<strong>'.$page.'</strong>';
				else
					$navigation .= '<a href="'.$out.$page.$options_url.'">'.$page.'</a>';
			} //
			else
				$navigation .= $page;

			$navigation .= ' - ';
		}

		$navigation = str_replace(' - ... - ', ' ... ', $navigation);
		$navigation = substr($navigation, 0, strlen($navigation)-3);

		if($page_precedente != 0)
			$bouton_precedent = '<a href="'.$out.$page_precedente.$options_url.'" class="fleche" title="Page prcdente">&laquo; les '.$nb_msg_par_page.' prcdentes</a>';

		if($page_suivante <= $nombre_de_pages)
			$bouton_suivant = '<a href="'.$out.$page_suivante.$options_url.'" class="fleche" title="Page suivante">les '.$nb_msg_par_page.' suivantes &raquo;</a>';

		if(isset($bouton_precedent) || isset($bouton_suivant)) {
			if(isset($bouton_precedent) && isset($bouton_suivant))
				$separation = ' - ';
			else
				$separation = null;

			$navigation .= '<br /><br />'.$bouton_precedent.$separation.$bouton_suivant;
		}

		echo $navigation;
		return true;
	}
}
?>

<html>
<head>
<?php if(isset($_GET['login'])): ?>
	<title>Accs restreint - JSAND</title>
<?php elseif($menu): ?>
	<title>Les visionneuses - JSAND</title>
<?php elseif($listing): ?>
	<title>Listing : <?php echo $titre_listing ?> (<?php echo ucfirst($visionneuse_mere) ?>) - JSAND</title>
<?php else: ?>
	<title>Visionneuse : <?php echo ucfirst(str_replace($pointeur_public, null, $album)) ?> - JSAND</title>
<?php endif; ?>

<style type="text/css">
BODY {
	font: normal 15px Verdana, Arial, Helvetica, sans-serif;
	background-color: #BBC2BB;
	text-align: center;
}

A:link, A:active, A:visited {
	text-decoration: none;
	font-weight: bold;
	color: #59695F;
}

A:visited {
	color: #777;
	font-style: italic;
}

A:hover { color: #000 }

A.fleche:link, A.fleche:active, A.fleche:visited, A.fleche:hover {
	background-color: #88938D;
	padding: 2px 5px 2px 5px;
	border: 1px solid #BBC2BB;
	color: #59695F;
}

A.fleche:hover {
	color: #FFF;
	background-color: #BBC2BB;
	border: 1px solid #88938D;
}

IMG { border: 4px solid #59695F }

INPUT {
	background-color: #FFF;
	border: 1px solid #000;
	text-align: center;
	font-size: 15px;
}

DIV.navigue {
	padding: 15px;
	background-color: #AFB5AF;
	margin: 20px 5px 40px 5px;
}

	DIV.navigue STRONG.pages { color: #59695F }

	DIV.navigue A.n1:link, DIV.navigue A.n1:active, DIV.navigue A.n1:visited {
		font-weight: bold;
		color: #777;
	}

DIV#naviguebas { margin: 40px 5px 30px 5px }

LI { list-style-type: square }

TABLE#menu {
	width: 94%;
	margin: 0 auto 0 auto;
}

TD#ulright { text-align: right }

	TD#ulright LI { list-style-type: none }
	TD#ulright EM { font-size: 10px }

A.copy:link, A.copy:active, A.copy:visited, A.copy:hover {
	font-size: 11px;
	font-style: italic;
	text-decoration: underline;
	color: #000;
}

A#deco:link, A#deco:active, A#deco:visited, A#deco:hover {
	background-color: #C00;
	border: 1px solid #C00;
	text-decoration: none;
	font-style: normal;
	font-size: 10px;
	padding: 0 2px 0 2px;
	color: #FFF;
}

A#deco:hover {
	background-color: #FFF;
	border: 1px solid #C00;
	color: #C00;
}

DIV.visionneuse_mere {
	font-weight: bold;
	color: #FFF;
	background-color: #AFB5AF;
	padding: 1px 3px 1px 5px;
	margin-bottom: 10px;
	border-top: 1px solid #59695F;
}

SPAN.password, SPAN.public {
	font-style: italic;
	font-size: 9px;
}

SPAN.password { color: #C00 }
SPAN.public { color: #009E00 }

.gauche { text-align: left }

SPAN#bas, SPAN#bas A:link, SPAN#bas A:active, SPAN#bas A:visited, SPAN#bas A:hover { font-size: 9px }
</style>
</head>

<body>
<div class="gauche"> &nbsp;
<?php if(!isset($_GET['login'])): ?>
		<?php if(!$listing): ?>
			<a href="<?php echo '?'.$album.(($filtre) ? '&amp;'.$pointeur_filtreur : null) ?>" class="copy"><?php echo $visionneuse.'?'.$album.(($filtre) ? '&amp;'.$pointeur_filtreur : null) ?></a>
		<?php else: ?>
			<div class="visionneuse_mere"><?php echo ucfirst($visionneuse_mere) ?></div> &laquo; <a href="<?php echo '?'.$visionneuse_mere ?>" class="copy">Retour  la visionneuse</a>
		<?php endif; ?>
	
		<?php if((!isset($_GET['login']) && !PUBLIQUE && !$menu) || ($_SESSION['login'] === true && $menu)) echo ' &nbsp; <a href="?'.$album.'&amp;p='.$p.$options_url.'&amp;deconnect" id="deco"> Dconnexion </a>' ?>

		<?php if($lien_menu && !$listing): ?>
			<br /> &laquo; <a href="<?php echo '?'.$pointeur_menu.(($type_menu != 'all') ? ((PUBLIQUE) ? (($type_menu != 'public') ? '&amp;type=public' : null) : (($type_menu != 'prive') ? '&amp;type=prive' : null)) : null) ?>" class="copy">Menu des visionneuses</a>
		<?php endif; ?>
<?php endif; ?>
</div>

<?php if(isset($_GET['login'])): ?>
	<h2>Accs restreint</h2> (<?php print ((isset($_SESSION['essais'])) ? 3 - $_SESSION['essais'] : 3) ?> essais)

	<form method="post" action="">
	<input type="hidden" name="album" value="<?php echo $album ?>" />
	<input type="hidden" name="p" value="<?php echo $p ?>" />
	<input type="hidden" name="n" value="<?php echo $n ?>" />
	<input type="hidden" name="filtre" value="<?php echo $filtre ?>" />
	<input type="hidden" name="listing" value="<?php echo $listing ?>" />
	<div class="navigue">
		Mot de passe : <input type="password" name="pass" /> <input type="submit" name="login_on" value="Entrer" />
	</div>
	</form>

<?php else: ?>
	<?php if(!$menu && !$listing): ?>
		<h2><em><?php echo ucfirst(str_replace($pointeur_public, null, $album)) ?> (<?php echo $i ?> photos)</em></h2>

		<form method="get" action="?">
		<input type="hidden" name="<?php echo $album ?>" value="" />
		<?php if($filtre): ?> <input type="hidden" name="<?php echo $pointeur_filtreur ?>" value="" /> <?php endif; ?>
		Afficher <input type="text" size="2" name="n" value="<?php echo $n ?>" /> photos par page
		</form>

		<div class="navigue">
		<?php navigue($i) ?>
		</div>

		<?php echo $corps ?>

		<div class="navigue" id="naviguebas">
		<?php navigue($i) ?>
		</div>
	<?php else: ?>
		<?php if($listing): ?>
			<h2><em><?php echo $titre_listing ?> (<?php echo $i ?> fichiers)</em></h2>
		<?php else: ?>
			<h2><em> <?php
				switch($type_menu) {
					case 'prive': echo 'Visionneuses prives'; break;
					case 'public': echo 'Visionneuses publiques'; break;
					default: echo 'Les visionneuses';
				}
			?> (<?php echo $i ?> albums)</em></h2>
		<?php endif; ?>

		<div class="navigue gauche">
		<?php echo $corps ?>
		</div>
	<?php endif; ?>
<?php endif; ?>

<span id="bas">&copy; Visionneuse de dossier par <a href="http://www.jsand.net" class="copy">www.jsand.net</a></span>

</body>
</html>